\section{Complete Cryptography Systems}

\subsection{Public Crryptography}

\subsubsection{Digital Certificates}
With digital signature, the server only proves that it has the private key. it doesn't prove that the server can't be trusted yet, since anybody can create the private key. The digital certificate is a mechanism through which we can verify the ownership of a public key. This verification needs a third party. It's usually managed through a Public Key Infrastructure.

\subsubsection{Certificate Issuance}
the server server.com generate an RSA public and private key. The server has a public key that it wants the clients to trust. Therefore it creates a Certificate Signing Request (CSR). The CSR is sent to a Cetficiation Authority (CA). For Example: Geotrust, Globalsign, Digicert etc.

The CA creates and signs the certificate with its private key and sends it back to the server. The server has now a certificate signed by a CA. that it can use to prove its identity.

\subsubsection{Certification Use}
During a TLS handshake, the server supplies to the client a signature backed up by a certificate. The client has to use the public key in the certificate server.com to decrypt the signature. In oder to trust the public key in the server.com certificate, the server has to check that the digital signature at the bottom of the certificate is valid. The only way to check the validity of the signature at the bottom of the certificate is to use the public key of the issuer of the certificate (GlobalTrust SSL CA - G3 in the example) to decrypt the digital signature.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.4\textwidth]{certificateuse}
  \caption{Certificate Usage}
\end{figure}

\subsubsection{Chains of Trust}
To verify the trust in the server.com, we need to examine the digital certificate of the issuer of the certificate that signed it. In many cases, the chain involves multiple certificates. A root certificate is self-signed and is trusted because it is built into the operating system, the browser or the phone. If the root certificate is not on the machine, the connection is rejected.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{chainoftrust}
  \caption{Chain Of Trust}
\end{figure}
 
\subsection{Complete Cryptographic Systems}
The building blocks of cryptography need to be carefully assembled into protocols that keep our systems secure. There are numerous well-established protocols out there. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{buildingblocks}
  \caption{Building Blocks for Cryptographic Systems}
\end{figure}

\subsubsection{Authenticated Encryption with associated Data (AEAD)}
A modern cryptography algorithm has to guarantee the confidentiality as well as the integrity. A message authentication code (MAC) is often attacked to the end of the cipher-text.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{AEAD}
  \caption{AEAD}
\end{figure}

AES is a block cipher in CTR mode and GCM is the Message authentication code (MAC). GCM computes a Galois Message Authentication Code (GMAC) over the ciphertext and the additional data.


\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{AESGCM}
  \caption{AES-GCM}
\end{figure}

\subsubsection{ChaCha20\_Poly1305}
%TODO Add chacha20_poly1305
 
\subsection{Discussion}

\subsubsection{Protocol Hanshakes}

\begin{description}
	\item[1. Handshake Phase] \hfill \\
	Agree on a set of cryptographic protocols, e.g. AES 128, ECDH, RSA etc. Perform a key exchange to obtain session key and other values such as IV. Verify any authenticity using the public key.
	\item[2. Transport / Record Phase] \hfill \\
	Packets encrypted using the agreed cipher. Includes a MAC or similar to verify integrity.
\end{description}

\subsubsection{Common Protocol Issues}
\begin{description}
	\item[Ciphertexts tat aren't secured with a MAC] \hfill \\
	Ciphertexts not secured with MAC are vulnerable in transit. Ciphertexts are less vulnerable on disk.
	\item[Messages that don't include a time-stamp or counter] \hfill \\
	They are vulnerable to a reply attack.
	\item[Protocols that don't use the public key for authenticity] \hfill \\
	They are vulnerable to a man in the middle attack.
\end{description}

\subsubsection{Dos and Dont's}

\textbf{Dos}
\begin{itemize}
	\item Use cryptographically strong random numbers. In python this is os.random and os.urandom, not math.random (for example to generate RSA keys, DH private keys) 
	\item Use “recipe” layers where possible. They take the algorithm and protocol decisions out of your hands 
	\item Use ephemeral session keys for communication, and long-term public-keys for authentication 
	\item  Nonces are numbers only used once 
	\item  IVs must be unpredictable
\end{itemize}

\textbf{Dont's}
\begin{itemize}
	\item Implementing your own algorithms is a bad idea! 
	\item Never use hard-coded keys, convenience comes at a cost 
	\item Don’t use ECB mode. Prefer CBC, but better yet CTR or GCM 
	\item Don’t use small public key sizes. At least 2048 bits! Elliptic curve is preferable: P-256 or X25519
\end{itemize}
